# -----------------------------------------------------------------
#  KMET (K-tai ML Expansion Tool for fml)
#
#  Version 1.0
#  Update 2004/12/14
#  Programmed by Ochisuke ( http://www.geocities.jp/ochisuke/ )
# -----------------------------------------------------------------
# Please write "require 'kmet.pl'" at the bottom of your "cf" file.

$START_HOOK = q`
  require 'kmet_config.pl';
  use MIME::Base64;
  use Net::FTP;
  $Envelope{'fh:reply-to:'} = $From_address;
  my $kmet_err = "";
  my $insertstr = "From: $From_address\n";
  if ($printtime) {
    my($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime(time);
    my $exectime = sprintf("%02d:%02d:%02d", $hour, $min, $sec);
    $insertstr .= "Time: $exectime\n";
  }
  ##### Divide into Parts
  my $envtype = $Envelope{'h:content-type:'};
  my $envbody = $Envelope{'Body'};
  if ($envtype =~ /boundary=\"(.*)\"/i) {
    my $boundaryword = "--$1";
    my @orgparts = split(/$boundaryword/, $envbody);
    ##### For Attached Files
    if ($useftp) {
      for (@orgparts) {
        if (/base64/i and /name=\"(.*)\"/i) {
          my $p2filename = $1;
          ##### Rename if file name is encoded by base64
          if ($p2filename =~ /=\?iso-2022-jp\?b\?(.*)\?=/i) {
            $p2filename = decode_base64($1);
            @nameparts = split(/\./, $p2filename);
            $exte = pop(@nameparts);
            $p2filename = join('', @nameparts);
            $p2filename =~ s/\W//g;
            $p2filename = "renamed_$p2filename.$exte";
          }
          ##### Read Sequence Number
          if (open(IN, './seq')) {
            my $mlseq = <IN>;
            $mlseq++;
            $p2filename = $mlseq . '_' . $p2filename;
            close(IN);
          } else {
            $kmet_err .= "Warn: No Sequence file.\n";
          }
          my($p2header, $p2body) = split(/\n\n/, $_, 2);
          my $p2binary = decode_base64($p2body); # Decode Base64
          ##### Write to File
          my $local_file = "$local_dir/$p2filename";
          if (!(-e $local_dir) and !mkdir($local_dir)) {
            $kmet_err .= "Error: Can't make local dir[$local_dir]. ($!)\n";
            next;
          }
          if (open(FILE, ">$local_file")) {
            binmode(FILE);
            print FILE $p2binary;
            close(FILE);
          } else {
            $kmet_err .= "Error: Can't save attached file[$local_file]. ($!)\n";
            next;
          }
          ##### Upload File to FTP Server
          my $remote_file = $p2filename;
          my $ftp = Net::FTP->new($ftphost);
          if (!$ftp) {
            $kmet_err .= "Error: Can't access ftp server. ($!)\n";
            unlink $local_file;
            next;
          }
          if (!$ftp->login($ftpuser, $ftppass)) {
            $kmet_err .= "Error: Can't login ftp server. ($!)\n";
            unlink $local_file;
            next;
          }
          if (!($ftp->cwd($remote_dir) or
            ($ftp->mkdir($remote_dir) and $ftp->cwd($remote_dir)))) {
            $kmet_err .= "Error: Can't make remote dir[$remote_dir]. ($!)\n";
            unlink $local_file;
            next;
          }
          $ftp->binary;
          if (! $ftp->put($local_file, $remote_file)) {
            $kmet_err .= "Error: Can't upload file[$remote_file]. ($!)\n";
            unlink $local_file;
            next;
          }
          $ftp->quit;
          ##### Make URL
          $insertstr = "File: http://$website$remote_dir/$remote_file\n$insertstr";
          unlink $local_file;
        }
      }
    }
    ##### Add Information in the Body
    my @resultparts = ();
    for (@orgparts) {
      if (/text\/plain/) {
        my($p1header, $p1body) = split(/\n\n/, $_, 2);
        $_ = "$p1header\n\n$kmet_err$insertstr\n$p1body";
      }
      push(@resultparts, $_);
    }
    $Envelope{'Body'} = join($boundaryword, @resultparts);
  } else {
    $Envelope{'Body'} = "$insertstr\n$envbody";
  }
`;

$SMTP_OPEN_HOOK = q%
  $Envelope{'fh:from:'} = $MAIL_LIST;
%;
